// if its slow its because of internet
#include <stdio.h>
#include <curl/curl.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
	char *string;
	size_t size;
} Response;

size_t write_chunk(void *data, size_t size, size_t nmemb, void *userdata);

int main(int argc, char** argv){
	if(argc != 2){fprintf(stderr, "how to use: ./curl_get_youtube_rss_link (the youtube video link(\n");exit(1);}

	CURL *curl;
	CURLcode result;

	curl = curl_easy_init();
	if(curl == NULL){fprintf(stderr, "HTTP request failed\n");return -1;}

	Response response;
	response.string = malloc(1);
	response.size = 0;

	curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_chunk);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, (void *) &response);

	result = curl_easy_perform(curl);
	if(result != CURLE_OK){fprintf(stderr, "Error: %s\n", curl_easy_strerror(result));return -1;}

	int start_of_title = 0;
	int end_of_title = 0;
	for(int i = 60000; i < strlen(response.string); i++){ // aparently the first 60000 are a waste
		if(response.string[i] == 116){ //t
			if(response.string[i+1] == 105){//i
				if(response.string[i+2] == 116){//t
					if(response.string[i+3] == 108){//l
						if(response.string[i+4] == 101){//e
							if(response.string[i+5] == 34){//"
								if(response.string[i+6] == 58){//:
									if(response.string[i+7] == 123){//{
										if(response.string[i+8] == 34){//"
											if(response.string[i+9] == 115){//s
												if(response.string[i+10] == 105){//i
													if(response.string[i+11] == 109){//m
														if(response.string[i+12] == 112){//p
															if(response.string[i+13] == 108){//l
																start_of_title = i+22;
																end_of_title = i+22+100;
																char title[100];
																int k = 0;
																for(int j = start_of_title; j <= end_of_title; j++){
																	title[k] = response.string[j];
																	k++;
																	if(j == end_of_title){
																		title[k] = '\0';
																	}
																}
																for(int l = strlen(title); l != 0; l--){
																	if(title[l] == 34 && title[l+1] == 125)
																		title[l] = '\0';
																}
																printf("%s\n", title);
																curl_easy_cleanup(curl); 
																free(response.string);
																return 0;
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

	return 0;
}

size_t write_chunk(void *data, size_t size, size_t nmemb, void *userdata){
	size_t real_size = size * nmemb; 
	Response *response = (Response *) userdata; 

	char *ptr = realloc(response->string, response->size + real_size + 1);
	if (ptr == NULL){
		return CURL_WRITEFUNC_ERROR;  
	}
	response->string = ptr;
	memcpy(&(response->string[response->size]), data, real_size);
	response->size += real_size;
	response->string[response->size] = 0; // '\0';

	return real_size;
}
